/**
 * file: GuitarHeroLite.kt
 *
 * DON'T FORGET TO WRITE THIS HEADER.
 */

import kotlin.math.pow
import processing.core.*
import ddf.minim.*

const val CONCERT_A = 440.0F
lateinit var out: AudioOutput
lateinit var stringA: GuitarString
lateinit var stringC: GuitarString

fun main(args: Array<String>) {
    PApplet.main("GuitarHeroLite")
}

class GuitarHeroLite : PApplet() {
    override fun settings() {
        size(512, 200)
    }

    override fun setup() {
        background(0)
        val minim = Minim(this)

        /*
         * Gets a line out from Minim, default bufferSize is 1024,
         * default sample rate is 44100, bit depth is 16
         */
        out = minim.getLineOut(Minim.STEREO)

        // Creates 2 guitar strings, one for A and the other for C.
        stringA = GuitarString(CONCERT_A)
        stringC = GuitarString(CONCERT_A * 2F.pow(3F / 12F))

        // Sets default size & alignment of text.
        textSize(32F)
        textAlign(CENTER)
    }

    override fun draw() {}

    override fun keyPressed() {
        background(0)
        text(key, width / 2F, height / 2F)
        if (key == 'a' || key == 'A')
            stringA.pluck()
        else if (key == 'c' || key == 'C')
            stringC.pluck()
    }
}
